// ElevatorSimulation.java
// Application with Elevator Model, View, and Controller (MVC)
package com.deitel.jhtp4.elevator;

// Java core packages
import java.awt.*;

// Java extension packages
import javax.swing.*;

// Deitel packages
import com.deitel.jhtp4.elevator.model.*;
import com.deitel.jhtp4.elevator.view.*;
import com.deitel.jhtp4.elevator.controller.*;

public class ElevatorSimulation extends JFrame {

   // model, view and controller
   private ElevatorModel model;
   private ElevatorView view;
   private ElevatorController controller;

   // constructor instantiates model, view, and controller
   public ElevatorSimulation()
   {
      super( "Deitel Elevator Simulation" );

      // instantiate model, view and ,controller
      model = new ElevatorModel();
      view = new ElevatorView();
      controller = new ElevatorController( model );

      // register View for Model events
      model.setElevatorModelListener( view );

      // add view and controller to ElevatorSimulation
      getContentPane().add( view, BorderLayout.CENTER );
      getContentPane().add( controller, BorderLayout.SOUTH );

   } // end ElevatorSimulation constructor

   // main method starts program
   public static void main( String args[] )
   {
      // instantiate ElevatorSimulation
      ElevatorSimulation simulation = new ElevatorSimulation();
      simulation.setDefaultCloseOperation( EXIT_ON_CLOSE );
      simulation.pack();
      simulation.setVisible( true );
   }
}