// Bell.java
// Represents Bell in simulation
package com.deitel.jhtp4.elevator.model;

// Deitel packages
import com.deitel.jhtp4.elevator.event.*;

public class Bell implements ElevatorMoveListener {

   // BellListener listens for BellEvent object
   private BellListener bellListener;

   // ring bell and send BellEvent object to listener
   private void ringBell( Location location )
   {
      if ( bellListener != null )
         bellListener.bellRang( 
            new BellEvent( this, location ) );
   }

   // set BellListener
   public void setBellListener( BellListener listener )
   {
      bellListener = listener;
   }

   // invoked when Elevator has departed
   public void elevatorDeparted( ElevatorMoveEvent moveEvent ) {}

   // invoked when Elevator has arrived
   public void elevatorArrived( ElevatorMoveEvent moveEvent )
   {
      ringBell( moveEvent.getLocation() );
   }
}