// Floor.java
// Represents a Floor located next to an ElevatorShaft
package com.deitel.jhtp4.elevator.model;

// Deitel packages
import com.deitel.jhtp4.elevator.ElevatorConstants;

public class Floor extends Location 
   implements ElevatorConstants {

   // reference to ElevatorShaft object
   private ElevatorShaft elevatorShaft;

   // Floor constructor sets name of Floor
   public Floor( String name )
   {
      setLocationName( name );
   }

   // get first or second Floor Button, using Location name
   public Button getButton()
   {
      if ( getLocationName().equals( FIRST_FLOOR_NAME ) )
         return getElevatorShaft().getFirstFloorButton();
      else

         if ( getLocationName().equals( SECOND_FLOOR_NAME ) )
            return getElevatorShaft().getSecondFloorButton();
      else

         return null;

   } // end method getButton

   // get first or second Floor Door, using Location name
   public Door getDoor()
   {
      if ( getLocationName().equals( FIRST_FLOOR_NAME ) )
         return getElevatorShaft().getFirstFloorDoor();
      else 

         if ( getLocationName().equals( SECOND_FLOOR_NAME ) )
            return getElevatorShaft().getSecondFloorDoor();
      else

         return null;

   } // end method getDoor

   // get ElevatorShaft reference
   public ElevatorShaft getElevatorShaft()
   {
      return elevatorShaft;
   }

   // set ElevatorShaft reference
   public void setElevatorShaft( ElevatorShaft shaft )
   {
      elevatorShaft = shaft;
   }
}